package ca.uwaterloo.ece651.fahrenheitconverter;

import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.EditText;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        final EditText fahrenheitInput = (EditText) findViewById(R.id.fahrenheitInput) ;
        final EditText celsiusOutput  = (EditText) findViewById(R.id.celsiusOutput) ;

        fahrenheitInput.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                /* Do nothing */
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                String celsiusTemperature = convertToCelsius(fahrenheitInput.getText().toString()) ;
                celsiusOutput.setText(celsiusTemperature);
            }

            @Override
            public void afterTextChanged(Editable s) {
                /* Do nothing */
            }
        }) ;
    }

    private String convertToCelsius(String input) {

        if (! (input.length() > 0 ))
            return  "";

        byte factor = 1 ;
        byte pos = 0 ;

        /* A negative number input */
        if (input.startsWith("-")) {

            /* No number available; only the '-' sign */
            if (input.length() == 1)
                return "";

            /* At least one number present */
            else {
                pos = 1 ;
                factor = -1 ;
            }
        }
        /* A negative number input */
        else if (input.startsWith("+")) {

            /* No number available; only the '+' sign */
            if (input.length() == 1)
                return "";

            /* At least one number present */
            else
                pos = 1 ;
        }


        Double res = (factor * Double.parseDouble(input.substring(pos)) - 32) / 1.8 ;
        return res.toString() ;
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
